#
# spec file for package apache2-mod_fastcgi (Version 2.4.2)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           apache2-mod_fastcgi
BuildRequires:  apache2-devel
%define modname mod_fastcgi
%define apxs /usr/sbin/apxs2
%define apache apache2
%define apache_libexecdir %(%{apxs} -q LIBEXECDIR)
%define apache_sysconfdir %(%{apxs} -q SYSCONFDIR)
%define apache_includedir %(%{apxs} -q INCLUDEDIR)
%define apache_serverroot %(%{apxs} -q PREFIX)
%define apache_localstatedir %(%{apxs} -q LOCALSTATEDIR)
%define apache_mmn        %(MMN=$(%{apxs} -q LIBEXECDIR)_MMN; test -x $MMN && $MMN)
Version:        2.4.2
Release:        40.7
License:        Other License(s), see package
Group:          Productivity/Networking/Web/Servers
Requires:       apache2 %{apache_mmn}
Autoreqprov:    on
Summary:        A FastCGI Module for Apache 2
Url:            http://www.fastcgi.com/
Source:         %{modname}-%{version}.tar.bz2
Patch1:         mod_fastcgi-2.4.2-apache22.dif
Patch2:         mod_fastcgi-2.4.2-poll.patch
Patch3:         mod_fastcgi-2.4.2-debug.dif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
FastCGI is a language independent, scalable, and open extension to CGI
that provides high performance without the limitations of server
specific APIs.

mod_fastcgi is a free open-source Apache HTTPD module.

FastCGI applications are very fast because they are persistent. There
is no per-request startup and initialization overhead.



Authors:
--------
    Open Market, Inc.

%prep
%setup -q -n %{modname}-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
cp -p Makefile.AP2 Makefile
export CFLAGS="$RPM_OPT_FLAGS -g"
make top_dir=/usr/share/apache2 INCLUDES="-I/usr/include/apache2 -I/usr/include/apache2-prefork"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{apache_libexecdir}
#make top_dir=/usr/share/apache2 DESTDIR=$RPM_BUILD_ROOT install
cp -p .libs/mod_fastcgi.so $RPM_BUILD_ROOT/%{apache_libexecdir}
mkdir -p $RPM_BUILD_ROOT/%{apache_sysconfdir}/conf.d
cat > $RPM_BUILD_ROOT/%{apache_sysconfdir}/conf.d/%{modname}.conf <<EOF
# protect the fcgi-bin directory if mod_fastcgi is not loaded
<IfModule !mod_fastcgi.c>
	<Directory "%{apache_serverroot}/fcgi-bin">
		AllowOverride None
		Options None
		Order allow,deny
		Deny from all
	</Directory>
</IfModule>
 
<IfModule mod_fastcgi.c>
 
	ScriptAlias /fcgi-bin/ %{apache_serverroot}/fcgi-bin/
	FastCgiIpcDir %{apache_localstatedir}/fastcgi
	# FastCGI applications can be static, dynamic, or external.
 
	# Dynamic FastCGI applications can be put in this directory. 
	# Use the FastCgiConfig directive in your httpd.conf.local
	# to change the defaults for them.
	# http://www.fastcgi.com/mod_fastcgi/docs/mod_fastcgi.html#FastCgiConfig
	<Directory "%{apache_serverroot}/fcgi-bin">
		AllowOverride None
		Options +ExecCGI -Includes
		SetHandler fastcgi-script
		Order allow,deny
		Allow from all
	</Directory>
	AddHandler fastcgi-script fcg fcgi fpl
 
	# Static or external FastCGI applications are started when apache
	# is started. They are configured with the
	# FastCgiServer and FastCgiExternalServer directives:
	# http://www.fastcgi.com/mod_fastcgi/docs/mod_fastcgi.html#FastCgiServer 
	# http://www.fastcgi.com/mod_fastcgi/docs/mod_fastcgi.html#FastCgiExternalServer
	# which can be put into httpd.conf.local.
	#
	# Examples:
	#FastCgiServer %{apache_serverroot}/fcgi-bin/echo -processes 5
	#FastCgiServer %{apache_serverroot}/htdocs/some/path/echo.fcgi
 
	# see http://www.FastCGI.com/docs/faq.html#typical_httpd.conf for more 
	# information...
 
</IfModule>
 
# vim: ft=apache
EOF
mkdir -p $RPM_BUILD_ROOT/%{apache_serverroot}/fcgi-bin
mkdir -p $RPM_BUILD_ROOT/%{apache_localstatedir}/fastcgi

%files
%defattr(-,root,root)
%doc CHANGES docs/*
%{apache_libexecdir}/%{modname}.so
%dir %{apache_serverroot}/fcgi-bin
%config(noreplace) %{apache_sysconfdir}/conf.d/%{modname}.conf
%attr(700,wwwrun,root) %dir %{apache_localstatedir}/fastcgi

%changelog
* Tue Jun 10 2008 poeml@suse.de
- build service supports the debuginfo flag in metadata now; remove
  debug_package macro from the specfile therefore.
* Fri Jul 20 2007 poeml@suse.de
- enable the workaround which disarms fcgi_util_fs_is_path_ok()
* Wed Jul 18 2007 poeml@suse.de
- add mod_fastcgi-2.4.2-debug.dif, which works around a segfault in
  fcgi_util_fs_is_path_ok(), which seems to be called with
  fs_path=NULL sometimes? Anyway, the patch is disabled at the
  moment since the problem doesn't occur currently. Needs a proper
  fix if it comes back.
* Thu Nov 30 2006 poeml@suse.de
- use poll() instead of select() to overcome FD_SETSIZE limit of 1024
* Wed Nov 29 2006 poeml@suse.de
- fix one more occurrence of an obsolete symbol
- use absolute path to apxs2
* Wed Aug 30 2006 poeml@suse.de
- put package into the Build Service
* Wed Jan 11 2006 poeml@suse.de
- port to apache 2.2, by no longer using depracated 1.3 function
  calls
* Wed Jun  9 2004 poeml@suse.de
- update to 2.4.2
* Mon Jul 28 2003 poeml@suse.de
- don't explicitely strip binaries since RPM handles it, and may
  keep the stripped information somewhere
* Sun May 11 2003 poeml@suse.de
- new package
